function [state, options, optchanged] = GAGenSave(options, state, flag, DataStruct)
persistent iter total 

folder_path = [DataStruct.PathMatlab, DataStruct.FileNameMatlab];

% check for parent directory
if exist(folder_path,'dir') == 0
    % directory does not already exist, make it
    mkdir(folder_path);
end

% update current filename
currentFile = strcat(DataStruct.FileNameMatlab,'_',int2str(DataStruct.Current));
currentFile_path = [DataStruct.PathMatlab,DataStruct.FileNameMatlab,filesep, currentFile,'.mat'];

% check that file for current iteration exists
if exist(currentFile_path,'file') == 2
    % file exists
    load(currentFile_path,'GenData');

    iter = iter + 1;
else
    % file does not exist, initialize some variables
    GenData.Generation=1;     
    iter = 1;
    total = 0;
end

for i=1:DataStruct.population_size
    
    if i>1 % skips the first result, is this a bug??
        
        if state.Score(i) < DataStruct.max_fitness
            
            if state.Score(i)~=state.Score(i-1)
                
                total = total + 1;
                
                GenData.Population(total) = state.Population(i);
                GenData.Fitness(total)=state.Score(i);
                
            end
        end
    end
end


% only print to console when not deployed

if ~isdeployed
    iterStr = sprintf('Iteration: %d',iter);
    fprintf([iterStr,'\n'])

    totalStr = sprintf('Total Solutions: %d\n',total);
    fprintf(totalStr)

    genStr = sprintf('Current Generation: %d\n',state.Generation);
    fprintf(genStr)
end
save(currentFile_path, 'GenData');
% standard template code follows
optchanged = false;
if ~isdeployed
    switch flag
        case 'init'
            disp('Starting the algorithm');
        case {'iter','interrupt'}
            disp('Iterating ...')
        case 'done'
            disp('Performing final task');
    end    % GAGenSave()
end