%% assignSLPanalysis
% modfifed by Rob Williams
% original code by Gordon Chalmers

% This program is used after the genetic algorithm
% program.  It will take the matlab file of possible
% solutions, then get rid of duplicates and sort.

% The output file has the information of the genetic
% algorithm solutions.

function [AssignmentFrequency,topResults] = assignSLPanalysis(dataStruct)
%% for heatmap
total_y_next=0;
max_y_next=0;

QQ=zeros(dataStruct.number_measurements,dataStruct.number_measurements);
number_exp = 512;
        
for i=1:dataStruct.number_measurements
    for j=1:dataStruct.number_measurements
        if dataStruct.Qexp(1,i)~=999
            if dataStruct.Qpred(1,j)~=999
                temporary=corrcoef(dataStruct.Qexp(1:number_exp,i),dataStruct.Qpred(1:number_exp,j));
                QQ(i,j)=temporary(1,2); 
            end
        end
    end        
end

% coordinates
measurements=zeros(dataStruct.number_measurements,1);

% The interdistances of coordinates are calculated.
% residue=zeros(1,dataStruct.number_measurements);

for i=1:dataStruct.number_measurements
    
%     residue(i)=dataStruct.coordinate(i,1);
    
    xcoordinate(i)=dataStruct.coordinate(i,1)-dataStruct.coordinate(i,4);
    ycoordinate(i)=dataStruct.coordinate(i,2)-dataStruct.coordinate(i,5);
    zcoordinate(i)=dataStruct.coordinate(i,3)-dataStruct.coordinate(i,6);
    
    order_parameters(i)=dataStruct.coordinate(i,7);
    
end

    % update current filename   
    load(dataStruct.currentFile,'GenData');

    % The x_simulation will contain the information of unique
    % individuals of these fitnesses.

    z_calculation=GenData.Population;

    fitness_calculation=GenData.Fitness;

    x_measurement_cell=cell2mat(z_calculation);

    x_measurement = reshape(x_measurement_cell, [dataStruct.number_measurements,size(x_measurement_cell,2)/dataStruct.number_measurements]);
    x_measurement = x_measurement';

    %% fitness_measurement=vec2mat(x_fitness_cell,1);


    [x_measurement_next,unique_index]=unique(x_measurement,'rows');

    total_next=size(x_measurement_next,1);

    max_fit=100000;

    x_simulation=zeros(100,dataStruct.number_measurements);

    rdc=zeros(dataStruct.number_media,dataStruct.number_measurements);

    % The processing examines all population and
    % iterations to find all the unique individuals.

    y_next=0;

    y_simulation=zeros(1,(6+4*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3);
    temp_y_simulation=zeros(1,(6+4*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3);
    temp_y_next=0;

    for ipopulation=1:total_next

        x=x_measurement_next(ipopulation,:);   

        if fitness_calculation(unique_index(ipopulation))<dataStruct.fitness_cutoff

            disp(ipopulation)

            y=zeros(1,dataStruct.number_media);  rdc=zeros(dataStruct.number_media,dataStruct.number_measurements);

            rdc_fitness_individual=zeros(dataStruct.number_media,dataStruct.number_measurements);

            for media=1:dataStruct.number_media

                % The d is a single element of the cell array.  There are
                % population_size elements of the cell array.

                    inext=0;

                    total=0;

                    for i=1:dataStruct.number_measurements

                        if  xcoordinate(i)*xcoordinate(i)+ycoordinate(i)*ycoordinate(i)+zcoordinate(i)*zcoordinate(i)~=0

                            if dataStruct.D(media,x(i))~=999

                                total=total+1;

                            end

                        end

                    end

                    a = zeros(total,5);

                    b=zeros(1,total);

                    % the back calculation involves the order parameters

                    for i=1:dataStruct.number_measurements

                        if xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                            if dataStruct.D(media,x(i))~=999

                                if dataStruct.validation=="false"

                                    DS=dataStruct.D(media,x(i))/order_parameters(x(i));

                                end

                                if dataStruct.validation=="true"

                                    DS=dataStruct.D(media,x(i));

                                end

                                a(i,1)=ycoordinate(i)*ycoordinate(i)-xcoordinate(i)*xcoordinate(i);
                                a(i,2)=zcoordinate(i)*zcoordinate(i)-xcoordinate(i)*xcoordinate(i);
                                a(i,3)=2*xcoordinate(i)*ycoordinate(i);
                                a(i,4)=2*xcoordinate(i)*zcoordinate(i);
                                a(i,5)=2*ycoordinate(i)*zcoordinate(i);

                                b(i)=DS/dataStruct.Dmax*(xcoordinate(i)*xcoordinate(i)+ycoordinate(i)*ycoordinate(i)+zcoordinate(i)*zcoordinate(i))^(5/2);

                            end

                        end

                    end

                    yy=lscov(a,b');   %computing projection of matrix A on b, giving x

                    for i=1:dataStruct.number_measurements

                        if xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                            if dataStruct.D(media,x(i))~=999

                                if dataStruct.validation=="false"

                                    DS=dataStruct.D(media,x(i))/order_parameters(x(i));

                                end

                                if dataStruct.validation=="true"

                                    DS=dataStruct.D(media,x(i));

                                end

                                y2x2=ycoordinate(i)*ycoordinate(i)-xcoordinate(i)*xcoordinate(i);

                                z2x2=zcoordinate(i)*zcoordinate(i)-xcoordinate(i)*xcoordinate(i);

                                xy=2*xcoordinate(i)*ycoordinate(i);

                                xz=2*xcoordinate(i)*zcoordinate(i);

                                yz=2*ycoordinate(i)*zcoordinate(i);

                                rdc(media,i)=dataStruct.Dmax/(xcoordinate(i)*xcoordinate(i)+ycoordinate(i)*ycoordinate(i)+zcoordinate(i)*zcoordinate(i))^(5/2)*(yy(1)*y2x2+yy(2)*z2x2+yy(3)*xy+yy(4)*xz+yy(5)*yz);

                                z=DS-rdc(media,i);

                                y(media)=y(media)+z*z/(dataStruct.D(media,x(i)+dataStruct.number_measurements))/(dataStruct.D(media,x(i)+dataStruct.number_measurements));

                                rdc_fitness_individual(media,i)=z*z/(dataStruct.D(media,x(i)+dataStruct.number_measurements))/(dataStruct.D(media,x(i)+dataStruct.number_measurements));

                            end

                        end

                    end

                    y(media)=sqrt(y(media)/(total))*(total-5)/dataStruct.number_measurements;

                end




            % The nitrogen chemical shift is added.

            total=0;

            for i=1:dataStruct.number_measurements

                if  xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                    if dataStruct.nitrogen(x(i))~=999

                        if dataStruct.nitrogen(i+dataStruct.number_measurements)~=999

                            total=total+1;

                        end

                    end

                end

            end

            nitrogen_objective=0;

            nitrogen_fitness_individual=zeros(1,dataStruct.number_measurements);

            for i=1:dataStruct.number_measurements

                if dataStruct.nitrogen(x(i))~=999

                    if dataStruct.nitrogen(i+dataStruct.number_measurements)~=999

                        if xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                            nitrogen_fitness_individual(i)=(dataStruct.nitrogen(x(i))-dataStruct.nitrogen(dataStruct.number_measurements+i))*(dataStruct.nitrogen(x(i))-dataStruct.nitrogen(dataStruct.number_measurements+i))/dataStruct.nitrogen(2*dataStruct.number_measurements+i)/dataStruct.nitrogen(2*dataStruct.number_measurements+i);

                            nitrogen_objective=nitrogen_objective+nitrogen_fitness_individual(i);

                        end

                    end

                end

            end

            nitrogen_objective=(total/dataStruct.number_measurements)*sqrt(nitrogen_objective/total);



            % The hydrogen chemical shift is added.

            total=0;

            for i=1:dataStruct.number_measurements

                if  xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                    if dataStruct.hydrogen(x(i))~=999

                        if dataStruct.hydrogen(i+dataStruct.number_measurements)~=999

                            total=total+1;

                        end

                    end

                end

            end

            hydrogen_objective=0;

            for i=1:dataStruct.number_measurements

                if  xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                    if dataStruct.hydrogen(x(i))~=999

                        if dataStruct.hydrogen(i+dataStruct.number_measurements)~=999

                            hydrogen_fitness_individual(i)=(dataStruct.hydrogen(x(i))-dataStruct.hydrogen(dataStruct.number_measurements+i))*(dataStruct.hydrogen(x(i))-dataStruct.hydrogen(dataStruct.number_measurements+i))/dataStruct.hydrogen(2*dataStruct.number_measurements+i)/dataStruct.hydrogen(2*dataStruct.number_measurements+i);

                            hydrogen_objective=hydrogen_objective+hydrogen_fitness_individual(i);

                        end

                    end

                end

            end

            hydrogen_objective=(total/dataStruct.number_measurements)*sqrt(hydrogen_objective/total);        

            % now the noe        
            noe_objective=0;        
            noe_fitness=zeros(1,dataStruct.number_measurements);        
            noe_fitness_individual=zeros(dataStruct.number_measurements);
                    total=0;                
                    for i=1:dataStruct.number_measurements                    
                        if  xcoordinate(i)*xcoordinate(i)+ycoordinate(i)*ycoordinate(i)+zcoordinate(i)*zcoordinate(i)~=0                        
                            tempQ=size(dataStruct.Qexp(:,:),2);

                            if dataStruct.Qexp(1,x(i))~=999

                                if dataStruct.Qpred(:,i)~=999                                
                                    if  xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0                                    
                                        total=total+1;                                    
                                    end                                
                                end                            
                            end                        
                        end                    
                    end

                    for i=1:dataStruct.number_measurements                    
                        tempQ=size(dataStruct.Qexp(:,:),2);

                        if dataStruct.Qexp(1,x(i))~=999                        
                            if dataStruct.Qpred(1,i)~=999                            
                                if  xcoordinate(i)*ycoordinate(i)*zcoordinate(i)~=0

                                    noe_fitness_individual(i)=(1-QQ(x(i),i))^2/total;

                                    noe_objective = noe_objective + noe_fitness_individual(i);

                                    noe_fitness(i) = (1-QQ(x(i),i))^2/total;

                                end                            
                            end                        
                        end                    
                    end

            noe_objective = dataStruct.noe_factor*(total/dataStruct.number_measurements)*sqrt(noe_objective);
            fitness=0;

            fitness=fitness+ sum(y) + noe_objective;        
            fitness=fitness+hydrogen_objective+nitrogen_objective;


            % prepare the output        
            x_simulation(ipopulation,1:dataStruct.number_measurements)=dataStruct.D(x(1:dataStruct.number_measurements));

            y_next=y_next+1;

            %% solution        
            y_simulation(y_next,1:dataStruct.number_measurements)=x(1:dataStruct.number_measurements);

            %% calculated rdc        
            for i=1:dataStruct.number_media            
                y_simulation(y_next,((1+i)*dataStruct.number_measurements+1):(2+i)*dataStruct.number_measurements)=rdc(i,:);            
            end

            %% assigned nitrogen        
            for i=1:dataStruct.number_measurements            
                y_simulation(y_next,(2+dataStruct.number_media)*dataStruct.number_measurements+i)=dataStruct.nitrogen(x(i));            
            end

            %% assigned hydrogen        
            for i=1:dataStruct.number_measurements            
                y_simulation(y_next,(3+dataStruct.number_media)*dataStruct.number_measurements+i)=dataStruct.hydrogen(x(i));            
            end

            %% calculated noe                   
            y_simulation(y_next,((3+dataStruct.number_media+1)*dataStruct.number_measurements+1):(4+dataStruct.number_media+1)*dataStruct.number_measurements)=noe_fitness(:);        

            %% rdc        
            for i=1:dataStruct.number_media            
                y_simulation(y_next,(4+2*dataStruct.number_media)*dataStruct.number_measurements+i)=y(i);            
            end

            %% cs        
            y_simulation(y_next,(4+2*dataStruct.number_media)*dataStruct.number_measurements+dataStruct.number_media+1)=nitrogen_objective;        
            y_simulation(y_next,(4+2*dataStruct.number_media)*dataStruct.number_measurements+dataStruct.number_media+2)=hydrogen_objective;

            %% noe
            y_simulation(y_next,((4+2*dataStruct.number_media)*dataStruct.number_measurements+dataStruct.number_media+3):((4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+2))=noe_objective;

            %% total
            y_simulation(y_next,(4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3)=fitness;

            %% calculated fitness rdc

            for i=1:dataStruct.number_media

                y_simulation(y_next,((4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+(i-1)*dataStruct.number_measurements+1):((4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+i*dataStruct.number_measurements))=rdc_fitness_individual(i,:);

            end

            %% assigned nitrogen fitness

            y_simulation(y_next,((4+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4):((4+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_measurements))=nitrogen_fitness_individual(1:dataStruct.number_measurements);

            %% assigned hydrogen fitness

            y_simulation(y_next,((5+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4):((5+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_measurements))=hydrogen_fitness_individual(1:dataStruct.number_measurements);


            %% calculated noe fitness

            for i=1:dataStruct.number_media            
                y_simulation(y_next,((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4+(i-1)*dataStruct.number_measurements):((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+i*dataStruct.number_measurements))=noe_fitness_individual(1:dataStruct.number_measurements);    
            end


            %% total residue fitnesses        
            residue_fitness=zeros(1,dataStruct.number_measurements);

            for i=1:dataStruct.number_media            
                residue_fitness(1:dataStruct.number_measurements)=residue_fitness(1:dataStruct.number_measurements)+ ...
                y_simulation(y_next,((4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+(i-1)*dataStruct.number_measurements+1):((4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+i*dataStruct.number_measurements))+y_simulation(y_next,((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4+(i-1)*dataStruct.number_measurements):((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+i*dataStruct.number_measurements));
            end

            residue_fitness(1:dataStruct.number_measurements)=residue_fitness(1:dataStruct.number_measurements)+y_simulation(y_next,((4+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4):((4+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_measurements))+ ...
            y_simulation(y_next,((5+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+4):((5+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_measurements));


            %% fitnesses at each residue        
            y_simulation(y_next,((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_media*dataStruct.number_measurements+1):((6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_media*dataStruct.number_measurements+dataStruct.number_measurements))=residue_fitness(1:dataStruct.number_measurements);

            temp_y_next=temp_y_next+1;

            temp_y_simulation(temp_y_next,1:(6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_media*dataStruct.number_measurements+dataStruct.number_measurements)=y_simulation(y_next,1:(6+3*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3+dataStruct.number_media*dataStruct.number_measurements+dataStruct.number_measurements);

        end    
    end

    clear y_simulation;
    y_simulation=sortrows(temp_y_simulation,(4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3);

    second_y_next=y_next-1;

    for y_next=1:second_y_next    
        total_fitness=y_simulation(y_next,(4+2*dataStruct.number_media)*dataStruct.number_measurements+2*dataStruct.number_media+3);   

        if total_fitness <= dataStruct.fitness_cutoff        
            max_y_next=max_y_next+1;        
        end    
    end

save(dataStruct.outFile,'y_simulation');
    
%% calculate assignment frequency
total=zeros(dataStruct.number_measurements,dataStruct.number_measurements);

for i=1:max_y_next    
    for residue=1:dataStruct.number_measurements        
        total(y_simulation(i,residue),residue)=total(y_simulation(i,residue),residue)+1;        
    end    
end

AssignmentFrequency(:,:)=total(:,:)/max_y_next;

%% save top results, default 20
topResults = y_simulation(1:dataStruct.nTop,:);
end