function penalty = methylPairs(x)
%MethylPairs Penalize assignments which do not have methyl groups from the
%same residue in adjacent positions
%   Inputs
%       x - population of possible assignments

penalty = zeros(size(x,1),1);

for i = 1:size(x,1)
   
    current = x{i};
    
    for j = 1:2:size(current,2)
        
        if ~(abs(current(j) - current(j+1)) == 1)
           
            penalty(i) = penalty(i) + 1;
            
        end
        
    end
    
end

end

