%% noeScore - calculate NOE scoring function for AssignSLPGUI
% inputs
%   x - cell array containing assignment vectors,
%           n x 1 cell array of 1x12 double
%
%   DataStruct - structure variable used throughout the AssignSLPGUI code
%
% output
%   score - vector containing NOE scores of all assignments, n x 1 double

function score = noeScore(x,DataStruct)

score = zeros(size(x,1),1);

for j = 1:size(x,1)    
    d = x{j};       
    noe_objective = 0;  
    
 % noe
    total=0;

    for i=1:DataStruct.number_measurements
%         if DataStruct.xcoordinate(i)*DataStruct.ycoordinate(i)*DataStruct.zcoordinate(i)~=0
            if DataStruct.Qexp(1,d(i))~=999
                if DataStruct.Qpred(1,i)~=999
%                     if DataStruct.xcoordinate(i)*DataStruct.ycoordinate(i)*DataStruct.zcoordinate(i)~=0
                        total=total+1;
%                     end
                end
            end
%         end
    end
    
    for i=1:DataStruct.number_measurements
        if DataStruct.Qexp(1,d(i))~=999
            if DataStruct.Qpred(1,i)~=999
%                 if DataStruct.xcoordinate(i)*DataStruct.ycoordinate(i)*DataStruct.zcoordinate(i)~=0
                    noe_objective=noe_objective+(1-DataStruct.QQ(d(i),i))^2;
%                 end
            end
        end
    end
    noe_objective = (total/DataStruct.number_measurements)*sqrt(noe_objective/total);     
               
    fitness = DataStruct.noe_factor * noe_objective;
 
    score(j)=fitness;    
end


