%% pairMethyls - enforce pairing between valine methyls
% adds penalty for assignments with methyls in the same residue assigned to
% different residues
%
% assumes consecutive HSQC methyl peaks belong to the same residue
% this can generally be determined by NOESY or TOCSY data

function score = pairMethyls(x,DataStruct)
score = zeros(size(x,1),1);

for j = 1:size(x,1)  
    
    d = x{j};
    fitness = 0;
    
    for i=1:2:size(d,2)
        
        % adjacent peaks should be spaced by 1
        spacing = d(i) - d(i+1);
        
        % lower value peak number should also be odd, or else the register
        % has shifted by one
        m = min([d(i),d(i+1)]);
        isEven = mod(m,1);
        
        if (abs(spacing) > 1) 
            fitness = fitness + DataStruct.penalty;
        elseif isEven
            fitness = fitness + DataStruct.penalty;
        end        
    end    
    
    score(j)=fitness;  
    
end

end