%% Read NMR-STAR formatted ShiftX2 output

function CS = readShiftX(fileName)
    [~,~,ext] = fileparts(fileName);
    
    vars = {'atomID','resID','resName','atomName','CS','var6','chainID'};
    
    if strcmp(ext,'.cs')
        C = readtable(fileName,'FileType','text');
        if size(C,2) ~= 7
            error('Too many columns in ShiftX2 file, check input')
        end
    else
        error('Only .cs files supported')
%         C = readtable(fileName,'FileType','text');
    end
    C.Properties.VariableNames = vars;
    CS = C;
end