function simShifts = simulateHSQC(hsqc,csTol)
%simulateShifts This program takes a vector of chemical shifts and adds
%normally distributedrandom numbers to each value
%
%   Inputs:
%           hsqc        Predicted chemical shifts in the form of a HSQC
%                       peak list, n x 4 cell array
%           csTol       Chemical Shift tolerance, defines noise range, 
%                       [13C/15N Error, 1H Error], 1 x 2 double

[rows,cols] = size(hsqc);
simShifts = cell(rows,cols);
simShifts(:,1:2) = hsqc(:,1:2);

% get random noise and rescale to match errorTol
noise = randn(rows,2);
noise = noise .* csTol;

simShifts(:,3:4) = num2cell(cell2mat(hsqc(:,3:4)) + noise);
end

