%% slpPenalty - calculates a penalty for constraint violations, part of AssignSLPGUI
% inputs
%   x - cell array containing assignment vectors,
%           n x 1 cell array of 1x12 double
%
%   DataStruct - structure variable used throughout the AssignSLPGUI code
%
% output
%   score - vector containing scores of all assignments, n x 1 double

function score = slpPenalty(x,DataStruct)

rows = size(x,1);
score = zeros(rows,1);

for j = 1:rows
    d = x{j};
    fitness = 0;
    
    for i=1:DataStruct.number_measurements        
        if DataStruct.constraint_assignment(d(i),i)==0            
            fitness = fitness + DataStruct.penalty;            
        end        
    end    
    score(j)=fitness;  
end